#!/bin/bash

# Change the default passwords
export MYSQL_SERVER_PASS=0NlY0FfIcE@G4rr
read -sp "Enter the mysql password [ENTER]: " input; echo
if [ ! -z $input ]; then
   MYSQL_SERVER_PASS=$input
fi

export ONLYOFFICE_DOCUMENT_SERVER_PWD=onlyoffice
read -sp "Enter the document server password [ENTER]: " input; echo
if [ ! -z $input ]; then
   ONLYOFFICE_DOCUMENT_SERVER_PWD=$input
fi

export FQDN=ip-90-147-189-99.pa1.garrservices.it
read -p "Enter the FQDN of the host [ENTER]: " input
if [ ! -z $input ]; then
   FQDN=$input
fi

export MAIL_ADDR=attardi@garr.it
read -p "Enter the admin mail [ENTER]: " input
if [ ! -z $input ]; then
   MAIL_ADDR=$input
fi

# Get the installer
curl -s -O http://download.onlyoffice.com/install/install-Debian.sh

# Run the installer (-E to pass the environment)
sudo -E bash install-Debian.sh -os true

# Enable HTTPS

# Generate the certificates
if [ $SELF_SIGN == "true"]; then 
   cd /etc/ssl/private
   openssl genrsa -out onlyoffice.key 2048
   openssl req -new -key onlyoffice.key -out onlyoffice.csr
   openssl x509 -req -days 365 -in onlyoffice.csr -signkey onlyoffice.key -out onlyoffice.crt
   openssl dhparam -out dhparam.pem 4096
   chmod 400 onlyoffice.key onlyoffice.crt dhparam.pem
   export SSL_CERTIFICATE_PATH=/etc/ssl/private/onlyoffice.crt
   export SSL_KEY_PATH=/etc/ssl/private/onlyoffice.key
   export SSL_DHPARAM_PATH=/etc/ssl/private/dhparam.pem
else
   # Use Let\'s Encrypt
   # See: https://certbot.eff.org/lets-encrypt/ubuntubionic-nginx
   sudo apt install software-properties-common
   sudo add-apt-repository ppa:certbot/certbot
   sudo apt update
   sudo apt install letsencrypt
   sudo apt install python-certbot-nginx
   sudo certbot --nginx certonly -d $FQDN 
   export SSL_CERTIFICATE_PATH=/etc/letsencrypt/live/$FQDN/fullchain.pem
   export SSL_KEY_PATH=/etc/letsencrypt/live/$FQDN/privkey.pem
fi

# Configure nginx
sudo cp -f /etc/nginx/includes/onlyoffice-communityserver-common-ssl.conf.template /etc/nginx/sites-available/onlyoffice
# ONLYOFFICE_NIGNX_KEEPLIVE} is mispelled
sudo sed -i \
   -e "s:{{SSL_CERTIFICATE_PATH}}:$SSL_CERTIFICATE_PATH:" \
   -e "s:{{SSL_KEY_PATH}}:$SSL_KEY_PATH:" \
   -e "s:ssl_dhparam {{SSL_DHPARAM_PATH}}:${SSL_DHPARAM_PATH:-#ssl_dhparam}:" \
   -e "s/{{SSL_VERIFY_CLIENT}}/off/" \
   -e "s/{{ONLYOFFICE_NIGNX_KEEPLIVE}}/16/" \
   -e "s/ {{DOCKER_ONLYOFFICE_SUBNET}}/ #{{DOCKER_ONLYOFFICE_SUBNET}}/" \
   -e "s/\tssl_client_certificate/\t#ssl_client_certificate/" \
   -e "s/ ssl_stapling/ #ssl_stapling/" \
   -e "s/\tssl_trusted_certificate/\t#ssl_trusted_certificate/" \
   /etc/nginx/sites-available/onlyoffice

# Mail Aggregator
sudo sed -i -e 's/api-scheme" value="http/api-scheme" value="https/' /var/www/onlyoffice/Services/MailAggregator/ASC.Mail.Aggregator.CollectionService.exe.config

# Restart nginx
sudo service nginx restart
